#ifndef SRC_SAND_WEDGE_DATA_MYGRID_HH
#define SRC_SAND_WEDGE_DATA_MYGRID_HH

#include <boost/range/irange.hpp>
#include <boost/algorithm/cxx11/all_of.hpp>

#include <dune/common/fmatrix.hh>
#include <dune/grid/common/gridfactory.hh>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wdeprecated-declarations"
#include <dune/fufem/boundarypatch.hh>
#pragma clang diagnostic pop
#include <dune/fufem/boundarypatchprolongator.hh>

#include "mygeometry.hh"

template <class Grid> std::shared_ptr<Grid> constructGrid();

template <class GridView> struct MyFaces {
  BoundaryPatch<GridView> lower;
  BoundaryPatch<GridView> right;
  BoundaryPatch<GridView> upper;

#if DIM == 3
  BoundaryPatch<GridView> front;
  BoundaryPatch<GridView> back;
#endif

  MyFaces(GridView const &gridView);

private:
  bool isClose(double a, double b) {
    return std::abs(a - b) < 1e-14;
  };
};
#endif
